 % The program is for the TNF-a model published in the paper 'Huang, Z.,Senocak , F., Jayaraman, A., and Hahn, J. , BMC systems biology, 2008, 2:64'
 % Please refer to this paper for the details of the meaning for the parameters and states in the model. 
 % To whom correspondence should be addressed. Juergen Hahn, Tel.: (979) 845 3568, Fax: (979) 845 6446, e-mail: hahn@tamu.edu
 
 function dy=model_TNFa(t,y,TR)
 global k1p k15p k2p k16p k3p k17p k4p k18p k5p k19p k6p k20p k7p k21p k8p k22p k9p k23p k10p k24p k11p k25p k26p k14p k28p
 global kv c1 c2 c3 c4 c5 k2 k3 kdeg a2 a1 a3 t1 t2 c1a c2a c3a c4a c5a c6a 
 global i1 e2a i1a e1a c1c c2c c3c u

 %#########################################################################
 %y(1): TNFR1
 %y(2): TNF-a/TNFR
 %y(3): TRADD
 %y(4): TNF-a/TNFR1/TRADD
 %y(5): TRAF2
 %y(6): TNF-a/TNFR1/TRADD/TRAF2
 %y(7): RIP-1
 %y(8): TNF-a/TNFR1/TRADD/TRAF2/RIP-1
 %y(9):IKKn
 %y(10):TNF-a/TNFR1/TRADD/TRAF2/RIP-1/IKKn
 %y(11):IKKa
 %y(12):inactive IKK  
 %y(13):cytoplasmic (IKK|IkBa) complex 
 %y(14):cytoplasmic (IKK|IkBa|NFkB) complex
 %y(15):free cytoplasmic NFkB
 %y(16):free nuclear NFkB
 %y(17):cytoplasmic A20
 %y(18):A20 transcription
 %y(19):free cytoplasmic IkBa
 %y(20):free nuclear IkBan
 %y(21):IkB transcription
 %y(22):cytoplasmic (IkBa|NFkB) complex
 %y(23):Nuclear (IkBa|NFkB) complex
 %y(24):Control gene mRNA level or c-IAP
 %y(25):FADD
 %y(26):TNF-a/TNFR1/TRADD/TRAF2/RIP-1/FADD
 %y(27):TRADD/TRAF2/RIP-1/FADD
 %y(28):Caspase-8
 %y(29):TRADD/TRAF2/RIP-1/FADD/caspase-8
 %y(30):Caspase-8*
 %y(31):Caspase-3
 %y(32):Caspase-8*/caspase-3
 %y(33):Caspase-3*
 %y(34):DNA-fragmentation
 %y(35):Caspase-3*/c-IAP
 %y(36):DNA (intact)
 %y(37):Caspase-3*/DNA
 %######################################################################### 
 % TR=0 TNF off, TR=1 TNF on
dy=zeros(37,1);

dy(1) = -k1p*u*y(1)+k2p*y(2)+k17p*y(26)+k11p*y(10);
dy(2) = k1p*u*y(1)-k2p*y(2)-k3p*y(2)*y(3)+k4p*y(4);
dy(3) = -k3p*y(2)*y(3)+k4p*y(4)+k11p*y(10)+k20p*y(29);
dy(4) = k3p*y(2)*y(3)-k4p*y(4)-k5p*y(4)*y(5)+k6p*y(6);
dy(5) = -k5p*y(4)*y(5)+k6p*y(6)+k11p*y(10)+k20p*y(29);
dy(6) = k5p*y(4)*y(5)-k6p*y(6)-k7p*y(6)*y(7)+k8p*y(8);
dy(7) = -k7p*y(6)*y(7)+k8p*y(8)+k11p*y(10)+k20p*y(29);
dy(8) = k7p*y(6)*y(7)-k8p*y(8)-k9p*y(8)*y(9)+k10p*y(10)-k15p*y(8)*y(25)+k16p*y(26);
dy(9) = -k9p*y(8)*y(9)+k10p*y(10)+k14p*y(14);
dy(10) = k9p*y(8)*y(9)-k10p*y(10)-k11p*y(10);
dy(11) = k11p*y(10)-k3*y(11)-TR*k2*y(11)*y(17)-kdeg*y(11)-a2*y(11)*y(19)+t1*y(13)-a3*y(11)*y(22)+t2*y(14);
dy(12) = k3*y(11)+TR*k2*y(11)*y(17)-kdeg*y(12);
dy(13) = a2*y(11)*y(19)-t1*y(13);                                                                     
dy(14) = a3*y(11)*y(22)-t2*y(14);
dy(15) = c6a*y(22)-a1*y(15)*y(19)+t2*y(14)-i1*y(15);
dy(16) = i1*kv*y(15)-a1*y(20)*y(16);
dy(17) = c4*y(18)-c5*y(17);
dy(18) = c2+c1*y(16)-c3*y(18);
dy(19) = -a2*y(11)*y(19)-a1*y(19)*y(15)+c4a*y(21)-c5a*y(19)-i1a*y(19)+e1a*y(20);
dy(20) = -a1*y(20)*y(16)+i1a*kv*y(19)-e1a*kv*y(20);
dy(21) = c2a+c1a*y(16)-c3a*y(21);
dy(22) = a1*y(19)*y(15)-c6a*y(22)-a3*y(11)*y(22)+e2a*y(23);
dy(23) = a1*y(20)*y(16)-e2a*kv*y(23);
dy(24) = c2c+c1c*y(16)-c3c*y(24)-k28p*y(24)*y(33);
dy(25) = -k15p*y(8)*y(25)+k16p*y(26)+k20p*y(29);
dy(26) = k15p*y(8)*y(25)-k16p*y(26)-k17p*y(26);
dy(27) = k17p*y(26)-k18p*y(27)*y(28)+k19p*y(29);
dy(28) = -k18p*y(27)*y(28)+k19p*y(29);
dy(29) = k18p*y(27)*y(28)-k19p*y(29)-k20p*y(29);
dy(30) = k20p*y(29)-k21p*y(30)*y(31)+k22p*y(32)+k23p*y(32);
dy(31) = -k21p*y(30)*y(31)+k22p*y(32);
dy(32) = k21p*y(30)*y(31)-k22p*y(32)-k23p*y(32);
dy(33) = k23p*y(32)-k28p*y(24)*y(33)-k24p*y(36)*y(33)+k25p*y(37)+k26p*y(37);
dy(34) = k26p*y(37);
dy(35) = k28p*y(24)*y(33);
dy(36) = -k24p*y(36)*y(33)+k25p*y(37);
dy(37) = k24p*y(36)*y(33)-k25p*y(37)-k26p*y(37);









